//====================================================================
//    File: fet4xx_rtclcd.h
//
//    Version 1.0 first release for Application Report
//    06/04/04
//
//====================================================================

#if !defined(_fet4xx_rtclcd_h_)
#define _fet4xx_rtclcd_h_

#include "parameter.h"

#ifndef __STDC__ /* Begin #defines for assembler */

  #ifdef       _def_clock
   #define _imp_exp PUBLIC
  #else
   #define _imp_exp EXTERN
  #endif

  #ifdef __CROSSWORKS__
            _imp_exp  _SEC
            _imp_exp  _MIN
            _imp_exp  _HOUR
            _imp_exp  _DAY
            _imp_exp  _MONTH
            _imp_exp  _YEAR
            _imp_exp  _SetupClock
            _imp_exp  _SetupLCD
            _imp_exp  _Dis_Clock
            _imp_exp  _Dis_Date
            _imp_exp  _Display_BCD
            _imp_exp  _Char2LCD
            _imp_exp  _BCD2LCD
            _imp_exp  _Direct2LCD
            _imp_exp  _CHAR_SPACE
            _imp_exp  _CHAR_MINUS
            _imp_exp  _LCD_Tab
#if PCB == TI_BOARD
            _imp_exp  _TLCD_Tab
#endif
            _imp_exp  _setPoint
            _imp_exp  _setColon
            _imp_exp  _SetArrow
           .IMPORT   _DisplayNextData
  #else
            _imp_exp  SEC
            _imp_exp  MIN
            _imp_exp  HOUR
            _imp_exp  DAY
            _imp_exp  MONTH
            _imp_exp  YEAR
            _imp_exp  SetupClock
            _imp_exp  SetupLCD
            _imp_exp  Dis_Clock
            _imp_exp  Dis_Date
            _imp_exp  Display_BCD
            _imp_exp  Char2LCD
            _imp_exp  BCD2LCD
            _imp_exp  Direct2LCD
            _imp_exp  CHAR_SPACE
            _imp_exp  CHAR_MINUS
            _imp_exp  LCD_Tab
#if PCB == TI_BOARD
            _imp_exp  TLCD_Tab
#endif
            _imp_exp  setPoint
            _imp_exp  setColon
            _imp_exp  SetArrow
            EXTERN    DisplayNextData
  #endif
#else

// C part

#include "emeter-toolkit.h"

#define LCDchar(x,y) Char2LCD(x,y)
#define lcd_digit_table LCD_Tab

extern unsigned char SEC;
extern unsigned char MIN;
extern unsigned char HOUR;
extern unsigned char DAY;
extern unsigned char MONTH;
extern unsigned char YEAR;

extern const unsigned int CHAR_SPACE;
extern const unsigned int CHAR_MINUS;

extern const uint8_t lcd_digit_table[43];
extern const uint8_t TLCD_Tab[16];


void SetupClock(void);
void SetupLCD(void);
void Dis_Clock(void);
void Dis_Date(void);
void Display_BCD (unsigned char, unsigned char pos);
void Char2LCD (unsigned char, unsigned char pos);
void BCD2LCD (unsigned char, unsigned char pos);
void Direct2LCD (unsigned int, unsigned char pos);
void setPoint (unsigned char pos);
void setColon (unsigned char pos);
void SetArrow (unsigned char pos);

//void DisplayNextData(void);
#endif

#endif

